perf test: Replace arm spe fork test workload with sqrtloop

So that it can get rid of requirement of a compiler.  I've also removed
killall as it'll kill perf process now and run the test workload for 10
sec instead.

Signed-off-by: Namhyung Kim <namhyung@kernel.org>
Tested-by: James Clark <james.clark@arm.com>
Tested-by: Leo Yan <leo.yan@linaro.org>
Cc: Adrian Hunter <adrian.hunter@intel.com>
Cc: Athira Jajeev <atrajeev@linux.vnet.ibm.com>
Cc: German Gomez <german.gomez@arm.com>
Cc: Ian Rogers <irogers@google.com>
Cc: Ingo Molnar <mingo@kernel.org>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Peter Zijlstra <peterz@infradead.org>
Cc: Zhengjun Xing <zhengjun.xing@linux.intel.com>
Link: https://lore.kernel.org/r/20221116233854.1596378-9-namhyung@kernel.org
Signed-off-by: Arnaldo Carvalho de Melo <acme@redhat.com>
This commit is contained in:
Namhyung Kim 2022-11-16 15:38:50 -08:00 committed by Arnaldo Carvalho de Melo
parent 39281709a6
commit e011979ec4
1 changed files with 1 additions and 43 deletions

View File

@ -11,14 +11,7 @@ skip_if_no_arm_spe_event() {
skip_if_no_arm_spe_event || exit 2
# skip if there's no compiler
if ! [ -x "$(command -v cc)" ]; then
echo "failed: no compiler, install gcc"
exit 2
fi
TEST_PROGRAM_SOURCE=$(mktemp /tmp/__perf_test.program.XXXXX.c)
TEST_PROGRAM=$(mktemp /tmp/__perf_test.program.XXXXX)
TEST_PROGRAM="perf test -w sqrtloop 10"
PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
PERF_RECORD_LOG=$(mktemp /tmp/__perf_test.log.XXXXX)
@ -27,43 +20,10 @@ cleanup_files()
echo "Cleaning up files..."
rm -f ${PERF_RECORD_LOG}
rm -f ${PERF_DATA}
rm -f ${TEST_PROGRAM_SOURCE}
rm -f ${TEST_PROGRAM}
}
trap cleanup_files exit term int
# compile test program
cat << EOF > $TEST_PROGRAM_SOURCE
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
int workload() {
while (1)
sqrt(rand());
return 0;
}
int main() {
switch (fork()) {
case 0:
return workload();
case -1:
return 1;
default:
wait(NULL);
}
return 0;
}
EOF
echo "Compiling test program..."
CFLAGS="-lm"
cc $TEST_PROGRAM_SOURCE $CFLAGS -o $TEST_PROGRAM || exit 1
echo "Recording workload..."
perf record -o ${PERF_DATA} -e arm_spe/period=65536/ -vvv -- $TEST_PROGRAM > ${PERF_RECORD_LOG} 2>&1 &
PERFPID=$!
@ -78,8 +38,6 @@ echo Log lines after 1 second = $log1
kill $PERFPID
wait $PERFPID
# test program may leave an orphan process running the workload
killall $(basename $TEST_PROGRAM)
if [ "$log0" = "$log1" ];
then